/**
 * Hier der Kommentar fr das Package.
 * @see package-info.java (2)
 */
package src.beispiel2;
//(1)

/**
 *Kommentar zur Klasse Punkt (3).
 */
public class Punkt {

/**
 * Kommentar zu Konstante 1.
 */
public static final int PUNKT_EINS_X = 42;
/**
 * Kommentar zu Konstante 2.
 */
public static final int PUNKT_EINS_Y = 10;
/**
 * Kommentar zu Konstante 3.
 */
public static final int PUNKT_ZWEI_X = 17;
/**
 * Kommentar zu Konstante 4.
 */
public static final int PUNKT_ZWEI_Y = 19;
/**
 * Kommentar zu Konstante 5.
 */
public static final int SCALAR_MULT = 2;
/**
 *Kommentar zur Variable x.
 */
private double x;
/**
 *Kommentar zur Variable y.
 */
private double y;

/**
 *Kommentar zum Konstruktor mit den Uebergabe-Parametern.
 *
 *@param xx double
 *@param yy double
 */
//(4)
public Punkt(final double xx, final double yy) {
x = xx;
y = yy;
}

/**
 *Kommentar zur Main-Methode.
 *Hier sollen zwei Punkte erzeugt werden.
 *@param args String[]
 */
public static void main(final String[]  args) {
//Zwei Punkte erzeugen (5)


Punkt p1 = new Punkt(PUNKT_EINS_X, PUNKT_EINS_Y);
Punkt p2 = new Punkt(PUNKT_ZWEI_X, PUNKT_ZWEI_Y);
//(6)

System.out.println("p1.x = " + p1.x);
//(7)
System.out.println("p1.y = " + p1.y);
p1.x = 2 * p2.y;
System.out.println("p1.x = " + p1.x);
System.out.println("p1 = " + p1);
System.out.println("laenge zum Ursprung= " + p1.lenght());
System.out.println("Verschieben und neu = " + p1.skalarMult(SCALAR_MULT));
p1.skalarMultMod(SCALAR_MULT);
System.out.println("Veraendere Punkt 1 um s = " + p1);

}
/**
 *Kommentar zur Methode SetX.
 *@param tmpx Kommentar zum Uebergabeparameter.
 */
public final void setX(final double tmpx) { this.x = tmpx; }
//(8)
/**
 *Kommentar zur Methode SetY.
 *@param tmpy Kommentar zum Uebergabeparameter.
 */
public final void setY(final double tmpy) { this.y = tmpy; }

/**
 *Kommentar zur Methode GetX.
 *@return Kommentar zum Rueckgabewert.
 */
public final double getX() { return this.x; }
//(9)
/**
 *Kommentar zur Methode GetY.
 *@return Kommentar zum Rueckgabewert.
 */
public final double getY() { return this.y; }


/**
 *Kommentar zur Methode length.
 *@return Kommentar zum Rueckgabewert.
 */
public final double lenght() { return Math.sqrt(x * x + y * y); }

/**
 *Kommentar zur methode skalarMult.
 *@param s Kommentar zum Uebergabeparameter.
 *@return Kommentar zum Rueckgabewert.
 */
public final Punkt skalarMult(final double s) {
return new Punkt(x * s, y * s); }


/**
 *Kommentar zur Methode skalarMultMod.
 *@param s Kommentar zum Uebergabeparameter.
 */
public final void skalarMultMod(final double s) { x = s * x; y = s * y; }

/**
 *Kommentar zur Methode add.
 *@param tmp Kommentar zum Uebergabeparameter.
 *@return Kommentar zum Rueckgabewert.
 */
public final Punkt add(final Punkt tmp) {
return new Punkt(x + tmp.x, y + tmp.y); }


/**
 *Kommentar zur Methode addMod.
 *@param tmp Kommentar zum Uebergabeparameter.
 */
public final void addMod(final Punkt tmp) {
x = x + tmp.x;
y = y + tmp.y;
}


/**
 *Kommentar zur Methode toString.
 *@return Kommentar zum Rueckgabewert.
 */
public final String toString() { return "(" + x + ", " + y + ")"; }

}
